Attribute VB_Name = "tp_functions_sqlhandler"
Function sqlquery(file As String, query As String, Target As Range, Optional noheader As Byte)

'Liest eine Tabelle aus einer geschlossenen Arbeitsmappe als
' MS- Jet-Datenbank (DAO). Der Verweis auf DAO 3.6 im Modul
' aktivieren
' Damit die Sache korrekt arbeitet auf die Spalten- Formate
' (Felder) achten.

Dim DB As DAO.Database, RS As DAO.Recordset
Dim f As Long, lngR As Long, lngC As Long

Dim targetcell As Range
    On Error Resume Next
    Set DB = OpenDatabase(file, _
    False, False, "Excel 8.0;HDR=Yes;")
    On Error GoTo 0
    If DB Is Nothing Then
        MsgBox Err.Description, vbCritical, "SQL-Fehler"
        sqlquery = False
        Exit Function
    End If
    
' open a recordset
    On Error Resume Next
    ' SQL - String , die Feldnamen sind zu [], sollten den Regeln
    ' entsprechen
    ' [Tabelle1$] = Name der Tabelle mit $ erforderlich
    Set RS = DB.OpenRecordset(query) '
    'On Error GoTo 0
    If RS Is Nothing Then
        DB.Close
        Set DB = Nothing
        MsgBox Err.Description, vbCritical, "SQL-Fehler"
        sqlquery = False
        Exit Function
    End If
    'Recordset nach Worksheet
    'Ziel der Zelle im Worksheet
    'auch andere Zellen der Liste denkbar
    Set targetcell = Target
    With Application
        .Calculation = xlCalculationManual
        '.ScreenUpdating = False
        '.StatusBar = "Schreibe den RS ins Worksheet..."
    End With
    With targetcell.Cells(1, 1)
        lngR = .Row
        lngC = .Column
    End With
    
    With targetcell.parent
        .Range(.Cells(lngR, lngC), .Cells(.Rows.count, _
        lngC + RS.Fields.count - 1)).clear
        ' clear existing contents
        ' write column headers
        If noheader <> 1 Then
            For f = 0 To RS.Fields.count - 1
                On Error Resume Next
                .Cells(lngR, lngC + f).Formula = RS.Fields(f).Name
                On Error GoTo 0
            Next f
        End If
        ' write records
        On Error Resume Next
        RS.MoveFirst
        On Error GoTo 0
        If noheader = 1 Then lngR = lngR - 1
        Do While Not RS.EOF
            'If noheader <> 1 Then
            lngR = lngR + 1
            For f = 0 To RS.Fields.count - 1
                On Error Resume Next
                .Cells(lngR, lngC + f).value = RS.Fields(f).value
                On Error GoTo 0
            Next f
            RS.MoveNext
        Loop
    End With
    
    With Application
        '.StatusBar = False
        .Calculation = xlCalculationAutomatic
        '.ScreenUpdating = True
    End With
   
       RS.Close
    Set RS = Nothing
    DB.Close
    Set DB = Nothing
    sqlquery = True
End Function

